=== debian/changelog ===
pftools (3.2.6-1) unstable; urgency=medium

  * Team Upload.

  [ Andreas Tille ]
  * Fix watch file and homepage
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Upstream switched to cmake
  * Fix Perl interpreter in test scripts
  * Force sequential execution of tests
  * No need to replace [gh]top any more in examples
  * Lintian override for script-with-language-extension

  [ Nilesh Patra ]
  * Fix gcc-10 FTBFS
  * Remove man/* from debian/manpages
  * Remove duplicate manpage (already present in man/)
  * dh_auto_clean Clean remaining stuff
  * Remove useless files, move docs to correct place
  * Really fix perl interpreter path

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 18 Dec 2020 14:00:23 +0530
