=== debian/control ===
Source: pftools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               gfortran,
               cmake,
               libfile-slurp-perl,
               libbz2-dev,
               libpcre3-dev,
               libreadline-dev,
               zlib1g-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/pftools
Vcs-Git: https://salsa.debian.org/med-team/pftools.git
Homepage: https://github.com/sib-swiss/pftools3
Rules-Requires-Root: no

Package: pftools
Architecture: any-amd64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libfile-slurp-perl
Description: build and search protein and DNA generalized profiles
 The pftools package contains all the software necessary to build protein
 and DNA generalized profiles and use them to scan and align sequences,
 and search databases.
 .
 File formats used by the pftools
  * Generalized profiles format and syntax.
  * The multiple sequence alignment format (PSA).
  * The extended header multiple sequence alignment format (XPSA).
 .
 Programs to build generalized profiles
  pfmake
    Build a profile from a multiple sequence alignment.
  pfscale
    Fit parameters of an extreme-value distribution to a profile score list.
  pfw
    Weight sequences of a multiple sequence alignment to correct for
    sampling bias.
 .
 Programs to search with generalized profiles
  pfsearch / pfsearchV3
    Search a protein or DNA sequence library for sequence segments matching
    a profile (V3 is the new version of this tool).
  pfscan
    Scan a protein or DNA sequence with a profile library
 .
 Conversion programs
  psa2msa
    Reformat PSA file to Pearson/Fasta multiple sequence alignment file.
  ptof
    Convert a protein profile into a frame-search profile to search DNA
    sequences. To be used with 2ft.
  2ft
    Converts both strands of DNA into so-called interleaved
    frame-translated DNA sequences to search with protein profiles. To be
    used with ptof.
  6ft
    Translates all six reading frames of a double-stranded DNA sequence
    into individual protein sequences.
  pfgtop
    Convert a profile in GCG format into PROSITE format.
  pfhtop
    Convert a HMMER1 ASCII-formatted HMM into an equivalent PROSITE profile.
  ptoh
    Converts a generalized profile into an approximately equivalent HMM
    profile in HMMER1 format (can be read by the hmmconvert program from
    the HMMER2 package).
